pro plot1cmdmake

sun=sunsymbol()
loadct,3
znames=['zem5','zem4','z001','z002','z003','z004','z006','z008','z010','z014','z020','z030','z040']
mods=['0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1','1.1','1.2','1.3','1.5','1.5','1.7','2.1','2.3','2.5','3','4','5','6','7','8','9','10','20','30','40','50','60']
modsN=[0.1,0.5,1,3,5,10,20,30]
!x.style=1
!y.style=1
!p.charsize=1.5
!p.charthick=3
!p.thick=3

timebin=dblarr(51)
timebin(0)=10e0^(6.05)
for n=1,50 do timebin(n)=10e0^(6.05+n*0.1)-10e0^(6.05+0.1*(n-1))
print,timebin

levs=[-2e0,-1e0,0e0,1e-10,1e-9,1e-8,1e-7,1e-6,1e-5,1e-4,1e-3,1e-2,1e-1,1e0]


for zn=0,12 do begin

   models=dblarr(100,100,5,51)

   xdum="abc"
   xdum2="abc"
   modelimf=0D
   modeltype=1
   openr,5,"../BPASSv2.1_imf135_300/input_bpass_"+znames(zn)
   readf,5,totalimfnumber
   xdum5=dblarr(2)

   while(eof(5) eq 0) do begin
      readf,5,xdum2
      readf,5,xdum5
      modelimf=xdum5(0)
      modeltype=xdum5(1)
;0 - merger,  
;1 - normal primary, 
;2 - normal secondary,
;3 - single model,    
;4 - binary hmg to get black hole mass too  
      mixedage=0D
      mixedimf=0D
      if(modeltype ge 1.9) then begin;i.e. 2
         readf,5,xdum5
         mixedimf=xdum5(0)
         mixedage=xdum5(1)
         modelimf=modelimf-mixedimf
         if(modelimf lt 0e0) then modelimf=0e0
      endif
      initblackhole=0e0
      initperiod=0e0
      if(modeltype ge 3.9) then begin;i.e. 4
         readf,5,xdum5;initblackhole,initperiod ;!!so can put the black hole in at the end 
      endif
      
      dummy=fltarr(73)

      dum=strmid(xdum2,26,70)
      test1=FILE_TEST("/data/BPASSv2.1/"+dum)
                                ;   print,dum,test1
      if(test1 eq 1) then begin
         openr,6,"/data/BPASSv2.1/"+dum
         print,dum
         lasttime=0e0
         lasttime2=mixedage
         count=-1
         itmax=0
         itmax2=0
         itlast=0
         dummy(10)=1e0
         itlast2=round(10e0*alog10(mixedage))-60
         while(eof(6) eq 0 and dummy(1) le 100e9) do begin
            readf,6,dummy
            count=count+1
            dt=dummy(1)-lasttime
            if(dt gt 0d0) then begin
        
               it=round(10e0*alog10(dummy(1)))-60
               if(it le 0) then it=0
               if(it ge 50) then it=50
               itmax=it

               x0=25-round(5e0*((dummy(55))))       ;M(V)
               x1=50+round(10e0*(dummy(53)-dummy(54))) ;U-B
               x2=50+round(10e0*(dummy(55)-dummy(57))) ;V-I

               if(x0 ge 0 and x0 le 99 and x1 ge 0 and x2 ge 0 and x1 le 99 and x2 le 99) then begin
                  if(it eq itlast) then begin
                     models(x1,x0,0,it)=models(x1,x0,0,it)+dt*(modelimf)
                     models(x2,x0,1,it)=models(x2,x0,1,it)+dt*(modelimf)
                  endif else begin
                     if((it-itlast) gt 1) then begin
                        dum1=(10d0^(6.05d0+0.1d0*itlast))
                        dum2=(10d0^(5.95d0+0.1d0*it))
                        models(x1,x0,0,itlast)=models(x1,x0,0,itlast)+(dum1-lasttime)*(modelimf)
                        models(x2,x0,1,itlast)=models(x2,x0,1,itlast)+(dum1-lasttime)*(modelimf)
                        models(x1,x0,0,it)=models(x1,x0,0,it)+(dummy(1)-dum2)*(modelimf)
                        models(x2,x0,1,it)=models(x2,x0,1,it)+(dummy(1)-dum2)*(modelimf)
                        for n1x=itlast+1,it-1 do begin
                           dum1=(10d0^(6.05d0+0.1d0*(n1x))-10d0^(5.95d0+0.1d0*(n1x)))
                           models(x1,x0,0,n1x)=models(x1,x0,0,n1x)+(dum1)*(modelimf)
                           models(x2,x0,1,n1x)=models(x2,x0,1,n1x)+(dum1)*(modelimf)
                        endfor
                     endif else begin
                        dum1=10d0^(5.95d0+0.1d0*it)
                        models(x1,x0,0,itlast)=models(x1,x0,0,itlast)+(dum1-lasttime)*(modelimf)
                        models(x2,x0,1,itlast)=models(x2,x0,1,itlast)+(dum1-lasttime)*(modelimf)
                        models(x1,x0,0,it)=models(x1,x0,0,it)+(dummy(1)-dum1)*(modelimf)
                        models(x2,x0,1,it)=models(x2,x0,1,it)+(dummy(1)-dum1)*(modelimf)
                     endelse
                  endelse
                  
                  if(modeltype ge 1.9) then begin ;i.e. 2
                     it2=round(10e0*alog10(dummy(1)+mixedage))-60
                     if(it2 le 0) then it2=0
                     if(it2 ge 50) then it2=50
                     itmax2=it2                        
                     if(it2 eq it2last) then begin
                        models(x1,x0,0,it2)=models(x1,x0,0,it2)+dt*(mixedimf)
                        models(x2,x0,1,it2)=models(x2,x0,1,it2)+dt*(mixedimf)
                     endif else begin
                        if((it2-it2last) gt 1) then begin
                           dum1=(10d0^(6.05d0+0.1d0*it2last))
                           dum2=(10d0^(5.95d0+0.1d0*it2))
                           models(x1,x0,0,it2last)=models(x1,x0,0,it2last)+(dum1-lasttime2)*(mixedimf)
                           models(x2,x0,1,it2last)=models(x2,x0,1,it2last)+(dum1-lasttime2)*(mixedimf)
                           models(x1,x0,0,it2)=models(x1,x0,0,it2)+(dummy(1)+mixedage-dum2)*(mixedimf)
                           models(x2,x0,1,it2)=models(x2,x0,1,it2)+(dummy(1)+mixedage-dum2)*(mixedimf)
                           for n1=it2last+1,it2-1 do begin
                              dum1=(10d0^(6.05d0+0.1d0*(n1))-10d0^(5.95d0+0.1d0*(n1)))
                              models(x1,x0,0,n1)=models(x1,x0,0,n1)+(dum1)*(mixedimf)
                              models(x2,x0,1,n1)=models(x2,x0,1,n1)+(dum1)*(mixedimf)
                           endfor
                        endif else begin
                           dum1=10d0^(5.95d0+0.1d0*it2)
                           models(x1,x0,0,it2last)=models(x1,x0,0,it2last)+(dum1-lasttime2)*(mixedimf)
                           models(x2,x0,1,it2last)=models(x2,x0,1,it2last)+(dum1-lasttime2)*(mixedimf)
                           models(x1,x0,0,it2)=models(x1,x0,0,it2)+(dummy(1)+mixedage-dum1)*(mixedimf)
                           models(x2,x0,1,it2)=models(x2,x0,1,it2)+(dummy(1)+mixedage-dum1)*(mixedimf)
                        endelse
                     endelse
                  endif
            
               endif
               lasttime=dummy(1)
               itlast=round(10e0*alog10(dummy(1)))-60
               if(itlast le 0) then itlast=0
               if(itlast ge 50) then itlast=50
               it2last=round(10e0*alog10(dummy(1)+mixedage))-60
               if(it2last le 0) then it2last=0
               if(it2last ge 50) then it2last=50
               lasttime2=dummy(1)+mixedage
            endif
        endwhile
   
   
         close,6
      endif
      
   endwhile
   close,5
   SAVE, /VARIABLES, FILENAME = 'cmd-data-bin.'+znames(zn)+'.idl.dat'
   
endfor

end

