pro plot1cmdplot

models=dblarr(100,100,3)





axes=fltarr(100)
axes2=fltarr(100)
for n=0,99 do axes(n)=(25e0-n)/5e0
for n=0,99 do axes2(n)=(n-50e0)/10e0


mods=['1','3','5','10','12','15','20','30']
            
set_plot,'ps'
device,file="plot.ps",/color,bits=8,xsize=44.0,ysize=12.0
loadct,3
;!p.multi=[0,5,1]
znames=['zem5','zem4','z001','z002','z003','z004','z006','z008','z010','z014','z020','z030','z040']
znamestitle=['zem5','zem4','Z=0.001','Z=0.002','Z=0.003','Z=0.004','Z=0.006','Z=0.008','Z=0.010','Z=0.014','Z=0.020','Z=0.030','Z=0.040']
mods=['1','3','5','10','12','15','20','30','60']
modsN=[1,3,5,10,12,15,20,30]


levs=[0d0,1e-10,1e-9,1e-8,1e-7,1e-6,1e-5,1e-4,1e-3,1e-2,1e-1,1e0]

set_plot,'ps'
device,file="plot.cmd.ps",/color,bits=8,xsize=26.0,ysize=12.0

!x.style=1
!y.style=1
!p.charsize=1
!p.charthick=3
!p.thick=3
!x.margin=[7,1]
!x.omargin=[0,0]
!p.multi=[0,2,1]
loadct,13
for zn=0,12 do begin
      
   restore,"cmd-data-bin."+znames(zn)+".idl.dat"
      
   for xT=0,50 do begin      ;over time
         for xn0=0,1 do begin
          
            !y.title="M(V)"
            !y.range=[5,-15]
            if(xn0 eq 0) then !x.title="U-B"
            if(xn0 eq 1) then !x.title="V-I"
            if(xn0 eq 0) then !x.range=[-2,4]
            if(xn0 eq 1) then !x.range=[-2,5]

            contour,(models(0:99,0:99,xn0,xT))/max(models(0:99,0:99,xn0,xT)),axes2,axes,levels=levs,title=string(6+xT*0.1)+znames(zn),/fill

            
         endfor
      endfor
   
endfor

close,5
device,/close





close,6
   






close,5
device,/close


end
